/** przyklad wyscigu i uzycia blokady */
#include <boost/thread/mutex.hpp>
#include <boost/thread/thread.hpp>
#include <iostream>

class Counter
{
public:
    Counter() : count_(0) { }
	int getC() const { return count_; }
    void setC(int val) { count_ = val; }
private:
    int count_;
};

Counter counter;
boost::mutex mutex;

void thread_fun() {
	for(int i=0;i<1000000;++i) {
		boost::mutex::scoped_lock scoped_lock(mutex);
		counter.setC( counter.getC() + 1);
	}
}

int main() {
    const int NUM = 4;
    boost::thread_group thrds;
    for (int i=0; i < NUM; ++i)
        thrds.create_thread(&thread_fun);
    thrds.join_all();
	std::cout << "counter: " << counter.getC() << std::endl;
    return 0;
}



