#include <Stack.h>

#include <catch2/catch_test_macros.hpp>

using namespace swo::tdd;

TEST_CASE("new stack is empty", "[stack]") {
    Stack s;
    REQUIRE(s.isEmpty());
}

TEST_CASE("after push stack is no longer empty", "[stack]")
{
    Stack s;

    s.push(1);

    REQUIRE(!s.isEmpty());
}

TEST_CASE("after pop stack is empty again", "[stack]"){
    Stack s;
    s.push(1);

    s.pop();

    REQUIRE(s.isEmpty());
}

TEST_CASE("after two pushes and one pop the stack is not empty", "[stack]") {
    Stack s;
    s.push(1);
    s.push(42);

    s.pop();

    REQUIRE(!s.isEmpty());
}

TEST_CASE("pushed value is popped", "[stack]")
{
    Stack s;
    s.push(42);

    REQUIRE(s.pop() == 42);
}

TEST_CASE("last pushed value is popped", "[stack]") {
    Stack s;
    s.push(42);
    s.push(1);

    REQUIRE(s.pop() == 1);
}
